<?php
/**
 */

class MyOwnCurl {
    public $url;
    public $response;
    public $config;
    public $request_params;
    public $errors;
    public $module;
    const URL_PATH = 'https://www.myownsms.it/KeyController/';
    
    public function __construct($config = array()) {
        $this->errors = array();

        if (!extension_loaded('curl')) {
            throw new Exception(
                sprintf(
                    $this->module->l('The availability of php
                        %s library is not available on your server.
                        You can talk with the hosting provider to enable it.'),
                    'curl'
                )
            );
        }

        $this->config = $config;
    }

    public function curlit() {
        if (!function_exists('curl_init')) {
            throw new Exception(
                sprintf(
                    $this->module->l('The availability of php
                        %s library is not available on your server.
					    You can talk with the hosting provider to enable it.'),
                    'curl'
                )
            );
        } else {
            $c = curl_init();
            curl_setopt_array($c, array(
                CURLOPT_USERAGENT => 'spider',
                CURLOPT_RETURNTRANSFER => true,
                CURLOPT_HEADER => false,
                CURLOPT_FOLLOWLOCATION => false,
                CURLOPT_ENCODING => '',
                CURLOPT_URL => $this->url,
                CURLOPT_AUTOREFERER => true,
                CURLOPT_CONNECTTIMEOUT => 60,
                CURLOPT_TIMEOUT => 45,
                CURLOPT_MAXREDIRS => 10,
                CURLOPT_SSL_VERIFYPEER => false,
            ));
            $data_string = 'm=';
            $data_string .= json_encode($this->request_params);
            
            curl_setopt($c, CURLOPT_CUSTOMREQUEST, "POST");
            curl_setopt($c, CURLOPT_POSTFIELDS, $data_string);
            curl_setopt($c, CURLOPT_HTTPHEADER, array(
                'Content-Type: application/json',
                'Content-Length: ' . strlen($data_string)
                ));

            $response = curl_exec($c);
            if ($response === false) {
                $response = 'Curl error: ' . curl_error($c);
                $code = 1;
            } else {
                $code = curl_getinfo($c, CURLINFO_HTTP_CODE);
            }

            $info = curl_getinfo($c);

            curl_close($c);

            $this->response['code'] = $code;
            $this->response['response'] = $response;
            $this->response['info'] = $info;
            return $code;
        }
    }

    public function requestPost($url, $params = array()) {
        $this->prepareMethod("POST");
        $this->url = $url;
        $this->request_params = $params;
        $this->curlit();
        return json_decode($this->response['response']);
    }

    private function prepareMethod($method) {
        $this->method = strtoupper($method);
    }

    public function success() {
        return empty($this->errors);
    }

    public function getErrors() {
        return $this->errors;
    }
}
