<?php
/**
 */
//error_reporting(-1);
//ini_set('display_errors', 'On');

require_once(dirname(__FILE__) . '/../../config/config.inc.php');
define( 'SHORTINIT', true );

//require_once( ABSPATH . 'wp-load.php' );
require( dirname(__FILE__) . '/../../../../../wp-load.php' );
global $wpdb;

$log_file = 'polling.log';
try {
    MyOwnRequestService::parseRequest();
    $msms = myown_getQueryValue('m');
    $obj = json_decode($msms);
    myown_writeLog($log_file, 'message: ' . $msms);
} catch (Exception $ext) {
    myown_writeLog($log_file, 'Invalid Requiest. Message Wrong');
    $device_response = MyOwnResponseDevice::getMessageError(
        MyOwnResponseDevice::ERR_MES,
        "Invalid Requiest. Message Wrong"
    );
    $jsonResponse = json_encode($device_response);
    echo $jsonResponse;
    exit;
}

if (!isset($obj, $obj->{"ID_Device"}, $obj->{"Type_Message"})) {
    myown_writeLog($log_file, 'Invalid Requiest. Message Wrong');
    $device_response = MyOwnResponseDevice::getMessageError(
        MyOwnResponseDevice::ERR_MES,
        "Invalid Requiest. Message Wrong"
    );
    $jsonResponse = json_encode($device_response);
    echo $jsonResponse;
    exit;
}
$id_device = trim($obj->{"ID_Device"});
$type_message = trim($obj->{"Type_Message"});

$s_date_from = date( 'Y-m-d H:i', current_time( 'timestamp', 0 ));

switch ($type_message) {
    case MyOwnResponseDevice::REQUEST_POLLING:
        myown_writeLog($log_file, 'type ' . MyOwnResponseDevice::REQUEST_POLLING);
        $query = $wpdb->prepare( 
            "SELECT * FROM {$wpdb->prefix}myownsms_devices WHERE license = %s " ,
	        $id_device
        );
        myown_writeLog($log_file, $query);
        $row = $wpdb->get_row( $query, ARRAY_A);
        
        if (!isset($row)) {
            myown_writeLog($log_file, "Device Inesistente");
                $device_response = MyOwnResponseDevice::getMessageError(
                    MyOwnResponseDevice::ERR_DEVICE_NOT_FOUND,
                    "Non existent device"
                );
        } elseif ($row['state'] == 0) {
            myown_writeLog($log_file, 'state waiting del telefono ');
            $wpdb->update( 
                "{$wpdb->prefix}myownsms_devices", 
                array( 'state' => 1, 'date_ready' => $s_date_from ), 
                array( 'state' => 0, 'license' => $id_device ), 
                array( '%d', '%s' ), 
                array( '%d', '%d' ) 
            );
            
            $device_response = MyOwnResponseDevice::getMessageSubmit(
                MyOwnResponseDevice::OK_EMPTY,
                "No Message", array(), "", -1
            );
            
        } elseif ($row['state'] == 1) { // Device allineato correttamente
            myown_writeLog($log_file, 'state running ');
            $_id_dev = $row['id_device'];
            //testo se ho campagnie appese
            $_campaign = $wpdb->prepare( 
                "SELECT * FROM {$wpdb->prefix}myownsms_polling WHERE state = 0 AND id_device = %s AND date_begin <= %s " ,
                $_id_dev , $s_date_from
            );
            $_new_campaing = $wpdb->get_row( $_campaign, ARRAY_A);
                
            myown_writeLog($log_file, $_campaign);
            
            if ($_new_campaing && isset($_new_campaing['id_campaign'])) { //ho delle campagne appese
                myown_writeLog($log_file, "messaggio polling sottomesso");
                $device_response = MyOwnResponseDevice::getMessageSubmit(
                    MyOwnResponseDevice::OK_SUB,
                    $_new_campaing['message_sms'],
                    unserialize($_new_campaing['recipient']),
                    $_new_campaing['name_campaign'],
                    $_new_campaing['id_campaign']
                );
                
                $wpdb->update( 
                    "{$wpdb->prefix}myownsms_polling", 
                    array( 'state' => 1, 'date_processing' => $s_date_from ), 
                    array( 'state' => 0, 'id_campaign' => $_new_campaing['id_campaign']), 
                    array( '%d', '%s' ), 
                    array( '%d', '%d' ) 
                );
                //writeLog($log_file, "messaggio:  " . print_r($device_response, true));
            } else { //Messaggio vuoto
                $device_response = MyOwnResponseDevice::getMessageSubmit(
                    MyOwnResponseDevice::OK_EMPTY,
                    "No Message", array(), "", -1
                );
            }
        } else {
            $device_response = MyOwnResponseDevice::getMessageError(
                MyOwnResponseDevice::ERR_DEVICE_STATE,
                "Error: Locked device"
            );
        }
        break;
    case MyOwnResponseDevice::REQUEST_TERMINATE:
        myown_writeLog($log_file, 'type ' . MyOwnResponseDevice::REQUEST_TERMINATE);
        if (isset( $obj->{"Message"},
                $obj->{"Message"}->{"Result"} ,
                $obj->{"Message"}->{"Jobs"}
            ) && $obj->{"Message"}->{"Result"} = true) {
            $jobs = $obj->{"Message"}->{"Jobs"};
            $s_date = $obj->{"Message"}->{"Data"};
            $_num_sms = $obj->{"Message"}->{"tot_SMS"};
            //writeLog($log_file, 'date ' . $_date_format . " jobs: " . $jobs);
            
            $wpdb->update( 
                "{$wpdb->prefix}myownsms_polling", 
                array( 'state' => 2, 'date_finish' => $s_date_from ), 
                array( 'state' => 1, 'id_campaign' => $jobs), 
                array( '%d', '%s' ), 
                array( '%d', '%d' ) 
            );
            
            $query = $wpdb->prepare( 
                "SELECT num_tot_sms FROM {$wpdb->prefix}myownsms_devices WHERE license = %s " ,
                $id_device
            );
                
            $_num_tot_sms = $wpdb->get_var( $query );
            myown_writeLog($log_file, 'query sms ' . $query . " n: " . $_num_tot_sms . " s: " . $_num_sms);
            $tot = $_num_tot_sms + $_num_sms;
            
            $result = $wpdb->update( 
                "{$wpdb->prefix}myownsms_devices", 
                array( 'num_tot_sms' => $tot ), 
                array( 'license' => $id_device ), 
                array( '%d' ), 
                array( '%d' ) 
            );
            $device_response = MyOwnResponseDevice::getMessageSuccess(
                MyOwnResponseDevice::OK_END,
                "Ok job finished"
            );
        } else {
            $device_response = MyOwnResponseDevice::getMessageSuccess(
                MyOwnResponseDevice::OK_END,
                "Ok job finished but not found"
            );
        }
        break;
    default:
        myown_writeLog($log_file, 'type default');
        $device_response = MyOwnResponseDevice::getMessageSuccess(
            MyOwnResponseDevice::OK_END,
            "Error"
        );
        break;
}

$jsonResponse = json_encode($device_response);
myown_writeLog($log_file, 'response: ' . $jsonResponse);
echo $jsonResponse;
