<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

function myownsms_plg_campaign() {
    add_submenu_page(
        'myownsms_menu',                    // ID Menu principale
        __( 'Store Campaign', 'wpmyownsms' ),       // Stringa per popolare il titolo del browser
        __( 'Store Campaign', 'wpmyownsms' ),       // Label del sottomenu
        'administrator',					// ruolo usato per il menu
        'myownsms_plg_campaign',            // ID del sotto menu
        create_function( null, 'myownsms_plg( "campaign" );' )  // Funzione di callback
    );
}
add_action( 'admin_menu', 'myownsms_plg_campaign' );

function myownsms_campaign_render(){
    $options = get_option( 'myownsms_plg_registration' );
    
    if( true == $options AND !empty($options['id_license']) ) {
        sync_user();
        $license = $options['id_license'];
        
        if (myown_getQueryIsset('hi_import-user')){
            $nonce = myown_getQueryValue('_wpnonce');
            if ( ! wp_verify_nonce( $nonce, 'import_customers' ) )
                wp_die( 'Nope! Security check failed!' );
            
            import_all();
        }
        
        $optionDevice = get_device_list();
        include_once WP_MYOWNSMS_CONTROLLER . "campaign/f_create_campaign.php";
        custom_registration_function();
        
        include_once WP_MYOWNSMS_CONTROLLER . "campaign/f_select_customers.php";
        $customers_sel = new MyOwn_Select_Customers();
        include_once WP_MYOWNSMS_TEMPLATE . "campaign/select_customers.php";
        
        include_once WP_MYOWNSMS_CONTROLLER . "campaign/f_delete_customers.php";
        $customers_del = new MyOwn_Delete_Customers();
        include_once WP_MYOWNSMS_TEMPLATE . "campaign/delete_customers.php";
        
        include_once WP_MYOWNSMS_TEMPLATE . "campaign/create_campaign.php";
    } else {
        echo '<div class="card pressthis cardmo">'.
            '<div><h2>'.__( 'Required license', 'wpmyownsms').'</h2></div>'.
            '</div>';
    }
}
add_action( 'campaign_render', 'myownsms_campaign_render' );

function get_device_list() {
    global $wpdb;
    $sql = "SELECT id_device, name_device ". 
            "FROM {$wpdb->prefix}myownsms_devices " .
            "WHERE state = 1 ";

    $result = $wpdb->get_results( $sql );
    $optionDevice = array();
    foreach ( $result as $device ) {
        $optionDevice[$device->name_device] = $device->id_device;
    }
    return $optionDevice;
}

function sync_user($udate_all = false){
    // prima inserisco nuovi utenti
    new_user_woocommerce_subscriber();
    
    //poi rimuovo utenti non piu registrati
    delete_user_subscriber_woocommerce();
    
    //se update_all è true azzero il campo update a tutti
    if ($udate_all) {
        force_update_user();
    } 
    update_user_woocommerce_myown();
}

function force_update_user() {
    global $wpdb;
    $sql_update = "UPDATE `{$wpdb->prefix}myownsms_subscriber` SET `update`=0";
    $wpdb->query( $sql_update ) ;
}

/**
 * Aggiunge nuovi utenti appena registrti
 * @global type $wpdb
 */
function new_user_woocommerce_subscriber(){
    global $wpdb;
    $update_subscriber = "INSERT INTO `{$wpdb->prefix}myownsms_subscriber` ".
        "(`id_address`, `id_status`, `subscriber` , `update`) ".
        "SELECT ID, 0, 1, 0 ".
        "FROM {$wpdb->prefix}users " .
        "LEFT JOIN `{$wpdb->prefix}usermeta` ON `{$wpdb->prefix}users`.ID = `{$wpdb->prefix}usermeta`.user_id " .
        "WHERE `ID` > ( SELECT IFNULL(MAX(`id_address`), 0) FROM `{$wpdb->prefix}myownsms_subscriber` ) ".
        "AND `{$wpdb->prefix}usermeta`.meta_key = 'billing_phone'";
    $wpdb->query( $update_subscriber ) ;
}

/**
 * Rimuove tutti gli utenti non piu presenti nella tabella
 * wp_users. La rimozione delgi ID avviene contestualmente sia in wp_myownsms_subscriber
 * sia in wp_myownsms_woo_customers
 * @global type $wpdb
 */
function delete_user_subscriber_woocommerce(){
    global $wpdb;
    $sql_delete =  "DELETE a1, a2 ".
            "FROM {$wpdb->prefix}myownsms_subscriber AS a1 " .
            "INNER JOIN {$wpdb->prefix}myownsms_woo_customers AS a2 ON a1.id_address = a2.user_id ".
            "WHERE id_address IN ( " .
                "SELECT * FROM ( " . 
                     "SELECT m.id_address " .
                     "FROM {$wpdb->prefix}myownsms_subscriber as m ".
                     "LEFT OUTER JOIN {$wpdb->prefix}users as a ON a.ID = m.id_address ".
                     "WHERE a.ID IS NULL " .
                ") as p ".
            ");";
    $wpdb->query( $sql_delete ) ;
}

function update_user_woocommerce_myown(){
    global $wpdb;
    $_id_customers_upd = $wpdb->get_results(
        "SELECT `id_address` FROM `{$wpdb->prefix}myownsms_subscriber` WHERE `update` = 0 ");
    
    if ( $_id_customers_upd ) {
        foreach ( $_id_customers_upd as $id_customer ) {
            //SELECT * FROM `wp_usermeta` WHERE `user_id` = 1
            $_all_customers_upd = $wpdb->get_results( $wpdb->prepare( 
                "SELECT * FROM `{$wpdb->prefix}usermeta` WHERE `user_id` =  %d", $id_customer->id_address) 
             );
            $billing_first_name = $billing_last_name = $billing_address_1 = $billing_city = 
                $billing_state = $billing_postcode = $billing_country = $billing_email = 
                $billing_phone = '';
            if ( $_all_customers_upd ) {
                
                //print_r($_all_customers_upd);
                foreach ( $_all_customers_upd as $_customer ) {
                switch ($_customer->meta_key) {
                    case 'billing_first_name':
                        $billing_first_name = $_customer->meta_value;
                        break;
                    case 'billing_last_name':
                        $billing_last_name = $_customer->meta_value;
                        break;
                    case 'billing_address_1':
                        $billing_address_1 = $_customer->meta_value;
                        break;
                    case 'billing_city':
                        $billing_city = $_customer->meta_value;
                        break;
                    case 'billing_state':
                        $billing_state = $_customer->meta_value;
                        break;
                    case 'billing_postcode':
                        $billing_postcode = $_customer->meta_value;
                        break;
                    case 'billing_country':
                        $billing_country = $_customer->meta_value;
                        break;
                    case 'billing_email':
                        $billing_email = $_customer->meta_value;
                        break;
                    case 'billing_phone':
                        $billing_phone = $_customer->meta_value;
                        break;
                    default:
                        break;
                    }
                }
            
                $test = $wpdb->replace( 
                    "{$wpdb->prefix}myownsms_woo_customers", 
                    array( 
                        'user_id' => $id_customer->id_address, 
                        'billing_first_name' => $billing_first_name,
                        'billing_last_name' => $billing_last_name,
                        'billing_address_1' => $billing_address_1,
                        'billing_city' => $billing_city,
                        'billing_state' => $billing_state,
                        'billing_postcode' => $billing_postcode,
                        'billing_country' => $billing_country,
                        'billing_email' => $billing_email,
                        'billing_phone' => $billing_phone
                    ), 
                    array( 
                        '%d','%s','%s', '%s', '%s', '%s', '%s', '%s', '%s', '%s',
                    ) 
                );
                if ($test) {
                   $wpdb->update( 
                        "{$wpdb->prefix}myownsms_subscriber", 
                        array( 'update' => 1 ), 
                        array( 'id_address' => $id_customer->id_address ), 
                        array( '%d' ), array( '%d' ) 
                    ); 
                } else {
                   add_settings_error(
                        'import_customers',
                        'string',
                        "Errore DB: ".$wpdb->show_errors(),
                        "error"
                    );  
                }
            } else {
                add_settings_error(
                    'import_customers',
                    'string',
                    "non carica gli ID ",
                    "error"
                ); 
            }
        }
    }
}

function import_all(){
    sync_user(true);
    $message = __( 'Import succesfull', 'wpmyownsms');
    $type = 'success';
    add_settings_error(
        'import_customers',
        'string',
        $message,
        $type
    ); 
}