<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

function myownsms_plg_configuration() {
    add_submenu_page(
        'myownsms_menu',                    // ID Menu principale
        __( 'Configuration', 'wpmyownsms' ),	// Stringa per popolare il titolo del browser
        __( 'Configuration', 'wpmyownsms' ),	// Label del sottomenu
        'administrator',					// ruolo usato per il menu
        'myownsms_plg_configuration',       // ID del sotto menu
        'myownsms_plg'                      // Funzione di callback
    );
}
add_action( 'admin_menu', 'myownsms_plg_configuration' );

function myownsms_configuration_render(){
    global $wpdb, $table_prefix;
    include_once WP_MYOWNSMS_TEMPLATE . "configurations/registration.php";
    $options = get_option( 'myownsms_plg_registration' );
    if( true == $options AND !empty($options['id_license']) ) {
        $license = $options['id_license'];
        
        if ( myown_getQueryValue('myownsms_registration_device') ) {
            include_once WP_MYOWNSMS_CONTROLLER . "configurations/f_registration_device.php";
            f_validation_register_device(myown_get_home_url(), $license);
        }
        
        if ( myown_getQueryValue('myownsms_remove_device') ) {
            $id_dev = myown_getQueryValue('myownsms_device_id');
            $wpdb->delete( "{$table_prefix}myownsms_devices", array( 'id_device' => $id_dev ), array( '%d' ) );
        }
        $_row = $wpdb->get_row( 
            "SELECT id_device, name_device, password FROM {$table_prefix}myownsms_devices WHERE state = 0"
        );
        if ($_row) {
            $id_device = $_row->id_device;
            $password = $_row->password;
            $name_device = $_row->name_device;
            include_once WP_MYOWNSMS_TEMPLATE."configurations/waiting_device.php";
        } else {
            include_once WP_MYOWNSMS_TEMPLATE . "configurations/registration_device.php";
        }
        
        include_once WP_MYOWNSMS_CONTROLLER . "configurations/f_list_devices.php";
        $customers_obj = new MyOwn_Device_List();
        include_once WP_MYOWNSMS_TEMPLATE . "configurations/list_devices.php";
    }
}
add_action( 'configuration_render', 'myownsms_configuration_render' );

/**
 * Provides default values for the Registration.
 */
function myownsms_plg_default_registration() {
	$defaults = array(
		'id_order'		=> '',
        'id_license'    => '',
        'date_license'  => ''
	);
	return apply_filters( 'myownsms_plg_default_registration', $defaults );
} // end myownsms_plg_default_registration

/**
 * Initializes the theme's display options page by registering the Sections,
 * Fields, and Settings.
 *
 */ 
function myownsms_initialize_theme_options() {
	// If the theme options don't exist, create them.
	if( false == get_option( 'myownsms_plg_registration' ) ) {	
		add_option( 'myownsms_plg_registration', apply_filters( 'myownsms_plg_default_registration', myownsms_plg_default_registration() ) );
	} // end if

	add_settings_section(
		'registration_settings_section',            // ID usato per identificare la sezione
		__( 'PLUGIN REGISTRATION', 'wpmyownsms' ),          // Titolo della sezione
		'myownsms_registration_options_callback',	// Funzione di callback per la sezione
		'myownsms_plg_registration'                 // Pagina in cui viene aggiunta la sezione
	);
	
    add_settings_field(	
		'id_order',                         // ID usato per identifiacare il campo
		__( 'Plugin\'s Order ID:', 'wpmyownsms' ),	// Label del campo				
		'myownsms_input_order_callback',	// funzione di rendering del campo
		'myownsms_plg_registration',        // Pagina dove verrà renderizzata
		'registration_settings_section',	// ID Sezione di appartenenza
		array(								// Array dei parametri passati alla funzione
			__( 'Activate your personal plugin.', 'wpmyownsms' ),
		)			
	);
	
	// Finally, we register the fields with WordPress
	register_setting(
		'myownsms_plg_registration',
		'myownsms_plg_registration',
        'myownsms_plg_validation_registration'
	);
	
} // end myownsms_initialize_theme_options
add_action( 'admin_init', 'myownsms_initialize_theme_options' );

function myownsms_registration_options_callback() {
	echo '<p>' . __( 'Use the order ID.', 'wpmyownsms' ) . '</p>';
}

function myownsms_input_order_callback() {
	$options = get_option( 'myownsms_plg_registration' );
    //echo print_r($options,true);
	echo '<input type="text" id="input_example" name="myownsms_plg_registration[id_order]" value="' . sanitize_text_field( $options['id_order'] ) . '" />';
}

function myownsms_plg_validation_registration( $input ){
    $message = __( 'Required an alphanumeric order', 'wpmyownsms');
    $type = null;
    $output = get_option( 'myownsms_plg_registration' );
    if (isset( $input['id_order'] ) && ctype_alnum($input['id_order']) ) {
        $request = new MyOwnRegisterDomain();
        $domain = myown_get_home_url();
        $response = $request->registerDomain(
            $domain,
            get_site_url(null, '/wp-content/plugins/'.WP_MYOWNSMS_NAME, 'https'),
            $input['id_order'],
            WP_MYOWNSMS_PREFIX,
            WP_MYOWNSMS_NAME,
            WP_MYOWNSMS_VERSION
        );
        if (isset($response, $response->{"Result"}, $response->{"Type_Message"}, $response->{"Message"})) {
            $msg = $response->{"Message"};

            if ($msg->{"Reset"} == true) {
                // clear all device for the historical
            }
            if ($response->{"Result"} === true) { //successo 200 e 201
                $output['id_order'] = strip_tags( stripslashes( $input[ 'id_order' ] ) );
                $output['id_license'] = strip_tags( stripslashes( $msg->{"ID_License"} ) );
                $output['date_license'] = strip_tags( stripslashes( $msg->{"Date"} ) );
                
                if ($response->{"Type_Message"} === 200) { //prima richiesta o richiesta non voluta
                    $message = __('License registered', 'wpmyownsms');
                    $type = 'updated';
                } elseif ($response->{"Type_Message"} === 201) { //reset
                    $message = __('License updated', 'wpmyownsms');
                    $type = 'updated';
                }
            } elseif ($response->{"Result"} ===
                false && $response->{"Type_Message"} === 214) {
                $message = strip_tags( stripslashes($msg->Text) );
                $type = 'error';
            } else {
                $message = strip_tags( stripslashes($msg->Text) );
                $type = 'error';
            }
        } else {
            $message = __('Unknown message', 'wpmyownsms');
            $type = 'error';
        }
    }
    add_settings_error(
        'requireIdOrderNumber',
        'number',
        $message,
        $type
    );
    return apply_filters( 'myownsms_plg_validation_registration', $output, $input );
}



