<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

function f_validation_register_device( $url, $license ) {
    global $wpdb, $table_prefix;
    include_once WP_MYOWNSMS_CL."MyOwnDevice.php";
    
    $message = __( 'Required a number', 'wpmyownsms');
    $type = null;
    
    check_admin_referer( 'register_device' );
    $name_device = trim( myown_getQueryValue('myownsms_registration_device_name') );
    if (!$name_device || empty($name_device) || !myown_isGenericName($name_device) ) {
        $message = __( 'Required a valid name', 'wpmyownsms');
        $type = 'error';
        add_settings_error(
            'myownsms_registration_device',
            'string',
            $message,
            $type
        ); 
        return;
    }
    
    $totalDeviceName = $wpdb->get_var( 
        $wpdb->prepare( 
            "SELECT COUNT(*) FROM {$table_prefix}myownsms_devices where name_device = %s",
            $name_device
        )
    );
    if ( $totalDeviceName > 0) {   //register id order
        $message = __( 'Device Name not available or in waiting status', 'wpmyownsms');
        $type = 'error';
    } else { //insert and register device to key controller
        $password = myown_createPassword();
        
        $request = new MyOwnDevice();
        $response = $request->addDevice(
            $url,$license, $password
        );

        if ( isset($response,$response->{"Result"},$response->{"Type_Message"}) &&
             $response->{"Result"} == true && $response->{"Type_Message"} == 301) {
            
            $device = $response->{"Message"}->{"ID_Device"};
            $date = new DateTime('NOW');
            $s_date = $date->format('Y-m-d H:i:s');
            $wpdb->insert( "{$table_prefix}myownsms_devices", 
                array( 
                    'password' => $password,
                    'license' => $device,
                    'name_device' => $name_device,
                    'state' => (int) 0,
                    'date_begin' => $s_date
                ), 
                array( 
                    '%s','%s','%s','%d','%s',
                ) 
            );
            
            //TODO update default device notifications
            
            $message = __( 'Device ' .$name_device. ' saved. Waiting sync...', 'wpmyownsms');
            $type = 'updated';
        } else {
            $message = __( 'Impossibile salvare su DB', 'wpmyownsms');
            $type = 'error';
        }
    }
    add_settings_error(
        'myownsms_registration_device',
        'string',
        $message,
        $type
    );
}

function myown_test_waiting_device() {
    global $wpdb, $table_prefix;
    $totalDeviceName = $wpdb->get_var( 
        $wpdb->prepare( 
            "SELECT COUNT(*) FROM {$table_prefix}myownsms_devices where name_device = %s",
            $name_device
        )
    );
}

function myown_createPassword() {
    global $wpdb, $table_prefix;
    do {
        $password = sprintf("%06d", mt_rand(1, 999999));
        $exist = $wpdb->get_var( 
            $wpdb->prepare( "SELECT COUNT(*) FROM {$table_prefix}myownsms_devices WHERE password = %s",
                $password
            )
        );
    } while ($exist > 0);
    return $password;
}
