<?php
if (!defined('ABSPATH')) {
    exit;
}

include_once WP_MYOWNSMS_CL . "MyOwnCsvIterator.php";

function myownsms_plg_import()
{
    add_submenu_page(
        'myownsms_menu', __('Import', 'wpmyownsms'), __('CSV Campaign', 'wpmyownsms'), 'administrator', 'myownsms_plg_import', create_function(null, 'myownsms_plg( "import" );')
    );
}
add_action('admin_menu', 'myownsms_plg_import');

function myownsms_import_render()
{
    $options = get_option( 'myownsms_plg_registration' );
    
    if( true == $options AND !empty($options['id_license']) ) {
        $delimiters = array(
            'comma' => ',',
            'semicolon' => ';',
            'pipe' => '|',
            'colon' => ':'
        );
        $total_errors = array();
        $upload = trim(myown_getQueryValue('submit'));
        if ($upload && !empty($upload) && $upload == 'Upload') {
            if (check_admin_referer('import_upload')) {
                $delimiter = trim(myown_getQueryValue('MYOWNSMS_DELIMITER'));
                if (!$delimiter) {
                    $total_errors[] = __("Require delimiter character", 'wpmyownsms');
                }
                $enclosure = trim(myown_getQueryValue('MYOWNSMS_ENCLOSER'));
                if (!$enclosure) {
                    $total_errors[] = __("Require encloser character", 'wpmyownsms');
                }

                $movefile = csv_upload("WPMYOWNSMS_IMPORTS");
                if (!$movefile || isset($movefile['error'])) {
                    $total_errors[] = strip_tags(stripslashes($movefile['error']));
                } else {
                    $fileImport = array();
                    $fileImport['filename'] = $movefile['file'];
                    $fileImport['delimiter'] = $delimiters[$delimiter];
                    $fileImport['enclosure'] = $enclosure;
                    add_option('myownsms_plg_fileimport', serialize($fileImport));
                }
                if (count($total_errors)) {
                    foreach ($total_errors as $err) {
                        add_settings_error(
                            'requireCsvFile', 'number', $err, 'error'
                        );
                    }
                } else {
                    add_settings_error(
                        'requireCsvFile', 'number', __("File is valid, and was successfully uploaded.\n", 'wpmyownsms'), 'updated'
                    );
                }
            }
        } elseif ($upload && !empty($upload) && $upload == 'Import Numbers') {
            $fileImport = unserialize(get_option('myownsms_plg_fileimport'));
            if (file_exists($fileImport['filename'])) {
                $mapping = array();
                $mapping['alias'] = myown_getQueryValue('MYOWNSMS_ALIAS');
                $mapping['phone_mobile'] = myown_getQueryValue('MYOWNSMS_PHONE_MOBILE');
                if ($mapping['alias'] < 0 || $mapping['phone_mobile'] < 0) {
                    $total_errors[] = __('Required Alias and Phone Mobile fields');
                }
                if (count($total_errors)) {
                    foreach ($total_errors as $err) {
                        add_settings_error(
                            'requireCsvFile', 'number', $err, 'error'
                        );
                    }
                } else {
                    $mapping['first_name'] = myown_getQueryValue('MYOWNSMS_FIRST_NAME');
                    $mapping['last_name'] = myown_getQueryValue('MYOWNSMS_LAST_NAME');
                    $mapping['city'] = myown_getQueryValue('MYOWNSMS_CITY');
                    $mapping['language'] = myown_getQueryValue('MYOWNSMS_LANGUAGE');
                    $csvIterator = new MyOwnCsvIterator(
                        $fileImport['filename'], $fileImport['delimiter'], $fileImport['enclosure']
                    );
                    $tot_line = importIntoTableIterator($csvIterator, $mapping);
                    $csvIterator->delete();
                    add_settings_error(
                        'requireCsvFile', 'number', __($tot_line . " Customers insert", 'wpmyownsms'), 'updated'
                    );
                    delete_option('myownsms_plg_fileimport');
                }
            }
        } elseif ($upload && !empty($upload) && $upload == 'Back') {
            $fileImport = unserialize(get_option('myownsms_plg_fileimport'));
            unlink($fileImport['filename']);
            delete_option('myownsms_plg_fileimport');
        }

        $_import = get_option('myownsms_plg_fileimport');
        if (!$_import) {
            include_once WP_MYOWNSMS_TEMPLATE . "import/import_upload.php";
        } else {
            try {
                $s_import = unserialize($_import);
                if (file_exists($s_import['filename'])) {
                    $csvIterator = new MyOwnCsvIterator(
                        $s_import['filename'], $s_import['delimiter'], $s_import['enclosure']
                    );
                    macthingFields($csvIterator);
                } else {
                    delete_option('myownsms_plg_fileimport');
                    include_once WP_MYOWNSMS_TEMPLATE . "import/import_upload.php";
                }
            } catch (Exception $ex) {
                add_settings_error(
                    'readCsvFile', 'read', __('Read file error', 'wpmyownsms'), 'error'
                );
                include_once WP_MYOWNSMS_TEMPLATE . "import/import_upload.php";
            }
        }

        $optionDevice = get_device_list();
        include_once WP_MYOWNSMS_CONTROLLER . "import/f_create_own_campaign.php";
        custom_own_registration_function();

        include_once WP_MYOWNSMS_CONTROLLER . "import/f_select_own_customers.php";
        $customers_sel = new MyOwn_Select_Own_Customers();
        include_once WP_MYOWNSMS_TEMPLATE . "import/select_own_customers.php";

        include_once WP_MYOWNSMS_CONTROLLER . "import/f_delete_own_customers.php";
        $customers_del = new MyOwn_Delete_Own_Customers();
        include_once WP_MYOWNSMS_TEMPLATE . "import/delete_own_customers.php";

        include_once WP_MYOWNSMS_TEMPLATE . "import/create_own_campaign.php";
    } else {
        echo '<div class="card pressthis cardmo">'.
            '<div><h2>'.__( 'Required license', 'wpmyownsms').'</h2></div>'.
            '</div>';
    }
}
add_action('import_render', 'myownsms_import_render');

function csv_upload($file_id)
{
    if (!function_exists('wp_handle_upload')) {
        require_once( ABSPATH . 'wp-admin/includes/file.php' );
    }
    $uploadedfile = $_FILES[$file_id];

    function wpse_183245_upload_dir($dirs)
    {
        $dirs['subdir'] = '/import';
        $dirs['path'] = WP_MYOWNSMS_IMPORT;
        $dirs['url'] = WP_MYOWNSMS_ASSETS_IMPORT;
        return $dirs;
    }
    add_filter('upload_dir', 'wpse_183245_upload_dir');

    function so_3261107_hash_filename($filename)
    {
        $ext = pathinfo($filename, PATHINFO_EXTENSION);
        $name = basename($filename, $ext);
        return $name . $ext;
    }
    add_filter('sanitize_file_name', 'so_3261107_hash_filename', 10);

    $movefile = wp_handle_upload(
        $uploadedfile, array('test_form' => false, 'mimes' => array('csv' => 'text/csv')
    ));

    remove_filter('sanitize_file_name', 'so_3261107_hash_filename', 10);
    remove_filter('upload_dir', 'wpse_183245_upload_dir');
    return $movefile;
}

function macthingFields($csvIterator)
{
    $table_fields = array(
        'alias', 'phone_mobile',
        'first_name', 'last_name', 'city', 'language',
    );

    $header = $csvIterator->header(); //skip header
    $f_options = '<option value="-1"></option>';
    foreach ($header as $key => $colum) {
        $f_options .= "<option value=" . $key . ">" . $colum . "</option>";
    }

    $filename = $csvIterator->getName();
    $match_select = '';
    foreach ($table_fields as $fields) {
        $match_select .= '<tr><th scope="row">';
        $match_select .= str_replace("_", " ", strtoupper($fields));
        $match_select .= '</th><td><select name="MYOWNSMS_' . strtoupper($fields) . '" id="MYOWNSMS_' . strtoupper($fields) . '">';
        $match_select .= $f_options;
        $match_select .= '</select></td></tr>';
    }
    include_once WP_MYOWNSMS_TEMPLATE . "import/import_submit.php";
}

function importIntoTableIterator($csvIterator, $mapping) {
    global $wpdb, $table_prefix;
    $date = new DateTime('NOW');
    $s_date = $date->format('Y-m-d H:i:s');
    $is_first = true;
    $_count = 0;
    $max = max(array_values($mapping));

    foreach ($csvIterator as $data) {
        if ($is_first) {
            $is_first = false;
            continue;
        }
        if ($max > count($data) - 1) {
            continue; //skip if the row is invalid
        }

        $_alias = trim($data[$mapping['alias']]);
        $_phone_mobile = trim($data[$mapping['phone_mobile']]);
        $_first_name = ($mapping['first_name'] == -1 ) ?
            null : trim($data[$mapping['first_name']]);
        $_last_name = ($mapping['last_name'] == -1 ) ?
            null : trim($data[$mapping['last_name']]);
        $_city = ($mapping['city'] == -1 ) ?
            null : trim($data[$mapping['city']]);
        $_language = ($mapping['language'] == -1 ) ?
            null : trim($data[$mapping['language']]);
        
        $wpdb->insert( "{$table_prefix}myownsms_import_customers", 
                array(
                    'first_name' => $_first_name,
                    'last_name' => $_last_name,
                    'alias' => $_alias,
                    'social_name' => null,
                    'city' => $_city,
                    'language' => $_language,
                    'phone_mobile' => $_phone_mobile,
                    'date_add' => $s_date,
                    'id_status' => 0,
                ), 
                array( 
                    '%s','%s','%s','%s','%s','%s','%s','%s','%d'
                ) 
            );
        $_count += 1;
    }
    return $_count;
}
