<?php

function create_own_campaign_validation( $title, $sms, $device, $submit_date ) {
    global $reg_errors;
    $reg_errors = new WP_Error; 
    
    if ( get_count_customers() == 0){
        $reg_errors->add('title', 'Requires at least one customer');
    }
    
    if ( empty( $title ) ) {
        $reg_errors->add('title', 'Title field is missing');
    }
    
    if ( empty( trim($sms) ) ) {
        $reg_errors->add('sms', 'Sms field is missing');
    }
    
    if ( empty( $device ) ) {
        $reg_errors->add('device', 'Device field is missing');
    }
    
    if ( is_wp_error( $reg_errors ) ) {
        foreach ( $reg_errors->get_error_messages() as $error ) {
            echo '<div class="notice notice-error is-dismissible">';
            echo $error . '<br/>';
            echo '</div>';
        }
    }
}

function complete_create_own_campaign($title, $sms, $id_device, $submit_date) {
    global $reg_errors, $wpdb;
    if ( 1 > count( $reg_errors->get_error_messages() ) ) {
        $query = "SELECT `id_customers` AS `id`, `phone_mobile` as phone " .
            "FROM {$wpdb->prefix}myownsms_import_customers AS sub " .
            "WHERE `id_status` = 1 " .
            "AND `phone_mobile` <> ''" ;
        
        $fetch_customers = $wpdb->get_results( $query );
        $a_recipient_id_customers = array();
        $a_recipient = array();
    
        foreach ($fetch_customers as $results) {
            $a_recipient_id_customers[] = $results->id;
            $a_recipient[] = $results->phone;
        }
        $wpdb->insert( 
            "{$wpdb->prefix}myownsms_polling", 
            array( 
                'id_device' => (int)$id_device,
                'name_campaign' => $title,
                'message_sms' => $sms,
                'recipient' => serialize($a_recipient),
                'num_tot_recipient' => (int) count($a_recipient),
                'recipient_id_customers' => serialize($a_recipient_id_customers),
                'date_begin' => $submit_date,
                'state' => (int) 0
            ), 
            array( 
                '%d', '%s', '%s', '%s', '%d', '%s', '%s', '%d'
            ) 
        );
        
        $wpdb->update( 
            "{$wpdb->prefix}myownsms_import_customers",
            array( 'id_status' => (int)0 ), 
            array( 'id_status' => 1 ), 
            array( '%d' ), 
            array( '%d' ) 
        );
        
        echo '<div class="notice notice-success is-dismissible">';
        echo '<p>Success</p><br/>';
        echo '</div>';
    }
}

function custom_own_registration_function() {
    if ( myown_getQueryValue('myownsms_create_own_campaign') ) {
        if ( isset( $_POST['_wpnonce'] ) && ! empty( $_POST['_wpnonce'] ) ) {
            $nonce  = filter_input( INPUT_POST, '_wpnonce', FILTER_SANITIZE_STRING );
            $action = 'create_own_campaign';
            if ( ! wp_verify_nonce( $nonce, $action ) )
                wp_die( 'Nope! Security check failed!' );
        }
        $title = sanitize_text_field( myown_getQueryValue('myownsms_create_own_campaign_title',''));
        $sms = trim( myown_getQueryValue('myownsms_create_own_campaign_sms',''));
        $id_device = sanitize_text_field( myown_getQueryValue('myownsms_create_own_campaign_id_device','') );
        $submit_date = sanitize_text_field( myown_getQueryValue('myownsms_create_own_campaign_id_date','') );
        create_own_campaign_validation( $title, $sms, $id_device, $submit_date );
        complete_create_own_campaign( $title, $sms, $id_device, $submit_date );
    }
}

function get_count_customers() {
    global $wpdb;
    $sql = "SELECT count(*) ". 
        "FROM {$wpdb->prefix}myownsms_import_customers " . 
        "WHERE id_status = 1 " ;

    $user_count = $wpdb->get_var( $sql );
    return $user_count;
}