<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

function myownsms_plg_notifications() {
    add_submenu_page(
        'myownsms_menu',
        __( 'Notifications', 'wpmyownsms' ),
        __( 'Notifications', 'wpmyownsms' ),
        'administrator',
        'myownsms_plg_notifications',
        create_function( null, 'myownsms_plg( "notifications" );')
    );
}
add_action( 'admin_menu', 'myownsms_plg_notifications' );

function myownsms_notifications_render(){
    global $wpdb, $table_prefix;
    $options = get_option( 'myownsms_plg_registration' );
    if( true == $options AND !empty($options['id_license']) ) {
        $license = $options['id_license'];
        include_once WP_MYOWNSMS_TEMPLATE . "notifications/notifications.php";
    } else {
        echo '<div class="card pressthis cardmo">'.
            '<div><h2>'.__( 'Required license', 'wpmyownsms').'</h2></div>'.
            '</div>';
    }
}
add_action( 'notifications_render', 'myownsms_notifications_render' );

function myownsms_plg_default_notification() {
	$defaults = array(
        'active' => false,
        'device' => 1,
        'international' => false,
        'new_order'	=> "",
        'pending'   => "",
        'on_hold'   => "",
        'processing'=> "",
        'completed' => "",
        'cancelled' => "",
        'refunded'  => "",
        'failed'    => "",
	);
	return apply_filters( 'myownsms_plg_default_notification', $defaults );
}
 
function myownsms_initialize_notification() {
	if( false == get_option( 'myownsms_plg_notifications' ) ) {	
		add_option( 'myownsms_plg_notifications', apply_filters( 'myownsms_plg_default_notification', myownsms_plg_default_notification() ) );
	}
	add_settings_section(
		'notifications_settings_section',
		__( 'Notifications setting', 'wpmyownsms' ),
		'myownsms_notifications_options_callback',
		'myownsms_plg_notifications'
	);
    add_settings_field(	
		'active',
		__( 'Activate Notification Function', 'wpmyownsms' ),
		'myownsms_input_active_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'device',
		__( 'Select device', 'wpmyownsms' ),
		'myownsms_input_device_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'international',
		__( 'Send International SMS', 'wpmyownsms' ),
		'myownsms_input_international_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'new_order',
		__( 'New Order message', 'wpmyownsms' ),
		'myownsms_input_new_order_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'pending',
		__( 'Pending Payment message', 'wpmyownsms' ),	
		'myownsms_input_pending_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'on_hold',
		__( 'On-Hold message', 'wpmyownsms' ),	
		'myownsms_input_on_hold_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'processing',
		__( 'Order Processing message', 'wpmyownsms' ),	
		'myownsms_input_processing_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'completed',
		__( 'Order Completed message', 'wpmyownsms' ),	
		'myownsms_input_completed_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'cancelled',
		__( 'Order Cancelled message', 'wpmyownsms' ),	
		'myownsms_input_cancelled_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'refunded',
		__( 'Payment Refund message', 'wpmyownsms' ),	
		'myownsms_input_refunded_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
    add_settings_field(	
		'failed',
		__( 'Payment Failure message', 'wpmyownsms' ),	
		'myownsms_input_failed_callback',
		'myownsms_plg_notifications',
		'notifications_settings_section'
	);
	register_setting(
		'myownsms_plg_notifications',
		'myownsms_plg_notifications',
        'myownsms_plg_validation_notifications'
	);
	
}
add_action( 'admin_init', 'myownsms_initialize_notification' );

function myownsms_notifications_options_callback() {
	echo '<p>' . __( 'Here can be activate Notifications system, select the default device to use, set if send SMS to international phones too, and set message for each status.', 'wpmyownsms' ) . '</p>';
}

function myownsms_input_active_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    $html = '<input type="checkbox" id="active" name="myownsms_plg_notifications[active]" value="1" ' . checked(1, $options['active'], false) . '/>';
    echo $html;
}

function myownsms_input_device_callback(){
    global $wpdb;
    $options = get_option( 'myownsms_plg_notifications' );
    
    $sql = "SELECT id_device, name_device ". 
            "FROM {$wpdb->prefix}myownsms_devices " .
            "WHERE state = 1 ";

    $result = $wpdb->get_results( $sql );
    $html = '<select id="device" name="myownsms_plg_notifications[device]">';
    foreach($result as $device){
        $selected = ($options['device'] == $device->id_device) ? 'selected="selected"' : '';
        $html .=  "<option value='$device->id_device' $selected>$device->name_device</option>";
    }
    $html .= '</select>';
    echo $html;
}

function myownsms_input_international_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    $html = '<input type="checkbox" id="active" name="myownsms_plg_notifications[international]" value="1" ' . checked(1, $options['international'], false) . '/>';
    echo $html;
}

function myownsms_input_new_order_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="new_order" name="myownsms_plg_notifications[new_order]" >' . sanitize_text_field($options['new_order']) . '</textarea>';
}

function myownsms_input_pending_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="_pending" name="myownsms_plg_notifications[pending]" >' . sanitize_text_field($options['pending']) . '</textarea>';
}

function myownsms_input_on_hold_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="on_hold" name="myownsms_plg_notifications[on_hold]" >' . sanitize_text_field($options['on_hold']) . '</textarea>';
}

function myownsms_input_processing_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="processing" name="myownsms_plg_notifications[processing]" >' . sanitize_text_field($options['processing']) . '</textarea>';
}

function myownsms_input_completed_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
	echo '<textarea id="completed" name="myownsms_plg_notifications[completed]" >' . sanitize_text_field($options['completed']) . '</textarea>';
}

function myownsms_input_cancelled_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="cancelled" name="myownsms_plg_notifications[cancelled]" >' . sanitize_text_field($options['cancelled']) . '</textarea>';
}

function myownsms_input_refunded_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="refunded" name="myownsms_plg_notifications[refunded]" >' . sanitize_text_field($options['refunded']) . '</textarea>';
}

function myownsms_input_failed_callback() {
	$options = get_option( 'myownsms_plg_notifications' );
    echo '<textarea id="failed" name="myownsms_plg_notifications[failed]" >' . sanitize_text_field($options['failed']) . '</textarea>';
}

function myownsms_plg_validation_notifications( $input ){
    $message = __( 'Update Succesful', 'wpmyownsms');
    $type = 'update';
    $output = get_option( 'myownsms_plg_notifications' );
    
    if (! isset( $input['active'] ) ) {
        $output['active'] = false;
    }
    if (! isset( $input['international'] ) ) {
        $output['international'] = false;
    }
    
    foreach( $input as $key => $value ) {
        $output[$key] = trim(strip_tags( stripslashes( $value ) ));
    }
    
    add_settings_error(
        'requireIdOrderNumber',
        'number',
        $message,
        $type
    );
    return apply_filters( 'myownsms_plg_validation_notifications', $output, $input );
}

function myown_owner_notification( $order_id ) {
    myownsms_process_status($order_id, 0, 'new_order');
}
add_action( 'woocommerce_new_order', 'myown_owner_notification', 10, 3 );

function myownsms_process_status( $order_id, $old_status, $status ) {
    $template_message = get_option( 'myownsms_plg_notifications' );
    if ($template_message['active'] == false){
        return;
    }
    $order = new WC_Order( $order_id );
    $order_items = $order->get_items();
    if (empty($order_items)) {
        return;
    }
    $shipping_phone = false;
    $international = ( $order->get_billing_country() && ( WC()->countries->get_base_country() != $order->get_billing_country() ) );
    $phone = $order->get_billing_phone();
    $status = str_replace( 'wc-', '', $status );
    $status = str_replace( '-', '_', $status );
    
    if ( $international && ( $template_message['international'] != 1 ) ) {
        return;
    } 
    
    $phone = myown_process_phone( $order, $phone, $international, $shipping_phone );
    if ( empty($template_message[$status])) {
        return;
    }
    $message = myown_process_variables($template_message[$status], $order);
    
    $date_from = new DateTime('NOW');
    $s_date_from = $date_from->format('Y-m-d H:i:s');
    if ( ! empty( $message) && ! empty( $phone ) && ! empty($template_message['device'])  )
        myown_send_sms( 'notification', $phone, $message, $template_message['device'], $s_date_from ); 
}
add_action( 'woocommerce_order_status_changed', 'myownsms_process_status', 10, 3 );

function myown_process_phone( $order, $phone, $international = false, $shipping = false, $owners_phone = false ) {
    $phone	= str_replace( array( '+','-' ), '', filter_var( $phone, FILTER_SANITIZE_NUMBER_INT ) );
    if ( ! $international )
        return $phone;
    
    $intl_prefix = myown_country_prefix( WC()->countries->get_base_country() );
    if ( ! $owners_phone ) {
        $intl_prefix = $shipping ? myown_country_prefix( $order->get_shipping_country() ) : myown_country_prefix( $order->get_billing_country() );
    }
    preg_match( "/(\d{1,4})[0-9.\- ]+/", $phone, $prefix );
    if ( strpos( $prefix[1], $intl_prefix ) !== 0 ) {
        $phone = $intl_prefix . $phone;
    }
    if ( strpos( $prefix[1], "+" ) !== 0 ) {
        $phone = "+" . $phone;
    }
    return $phone;
}

function myown_send_sms($title, $phone, $sms, $id_device, $submit_date) {
    global $reg_errors, $wpdb;
    $conteggio_device = $wpdb->get_var($wpdb->prepare(
        "SELECT COUNT(*) FROM {$wpdb->prefix}myownsms_devices where state = 1 and id_device = %s" , $id_device
    )); 
    if ($conteggio_device == 1) {
        $a_recipient_id_customers = array();
        $a_recipient = array($phone);
        $wpdb->insert( 
            "{$wpdb->prefix}myownsms_polling", 
            array( 
                'id_device' => (int)$id_device,
                'name_campaign' => $title,
                'message_sms' => $sms,
                'recipient' => serialize($a_recipient),
                'num_tot_recipient' => (int) count($a_recipient),
                'recipient_id_customers' => serialize($a_recipient_id_customers),
                'date_begin' => $submit_date,
                'state' => (int) 0
            ), 
            array( 
                '%d', '%s', '%s', '%s', '%d', '%s', '%s', '%d'
            ) 
        );
    }
}

function myown_process_variables( $message, $order ) {
    $_myown_order = array( "status", "prices_include_tax", "tax_display_cart", "display_totals_ex_tax", "display_cart_ex_tax", "customer_message", "customer_note", "post_status", "note" );
    $_myown_customer = array( "order_key", "billing_first_name", "billing_last_name", "billing_company", "billing_address_1", "billing_address_2", "billing_city", "billing_postcode", "billing_country", "billing_state", "billing_email", "billing_phone", "shipping_first_name", "shipping_last_name", "shipping_company", "shipping_address_1", "shipping_address_2", "shipping_city", "shipping_postcode", "shipping_country", "shipping_state", "shipping_method", "shipping_method_title", "payment_method", "payment_method_title", "order_discount", "cart_discount", "order_tax", "order_shipping", "order_shipping_tax", "order_total" );
    $_myown_order_special = array( "id_order", "order_date", "modified_date", "shop_name", "order_product" );
    $_myown_order_var = get_post_custom( $order->get_id() );
    
    preg_match_all( "/\[(.*?)\]/", $message, $search );
    foreach ( $search[1] as $variable ) { 
        $variable = strtolower( $variable );
        if ( !in_array( $variable, $_myown_order ) && !in_array( $variable, $_myown_customer ) && !in_array( $variable, $_myown_order_special ) && !in_array( $variable, $custom_variables ) ) {
            continue;
        }

        if ( !in_array( $variable, $_myown_order_special ) ) {
            if ( in_array( $variable, $_myown_order ) ) {
                $message = str_replace( "[" . $variable . "]", $order->$variable, $message ); //Standard fields
            } else if ( in_array( $variable, $_myown_customer ) ) {
                $message = str_replace( "[" . $variable . "]", $_myown_order_var["_" . $variable][0], $message ); //Meta fields
            }
        } else if ( $variable == "order_date"){ 
            $message = str_replace( "[" . $variable . "]", date_i18n( woocommerce_date_format(), strtotime( $order->get_date_created() ) ), $message );
        } else if ($variable == "modified_date" ) {
            $message = str_replace( "[" . $variable . "]", date_i18n( woocommerce_date_format(), strtotime( $order->get_date_modified() ) ), $message );
        } else if ( $variable == "shop_name" ) {
            $message = str_replace( "[" . $variable . "]", get_bloginfo( 'name' ), $message );
        } else if ( $variable == "id_order" ) {
            $message = str_replace( "[" . $variable . "]", $order->get_order_number(), $message );
        } else if ( $variable == "order_product" ) {
            $products = $order->get_items();
            $quantity = $products[key( $products )]['name'];
            if ( strlen( $quantity ) > 10 ) {
                $quantity = substr( $quantity, 0, 10 ) . "...";
            }
            if ( count( $products ) > 1 ) {
                $quantity .= " (+" .  ( count( $products ) - 1 ) .")";
            }
            $message = str_replace( "[" . $variable . "]", $quantity, $message );
        }
    }
    return $message;
}

function myown_country_prefix( $country = '' ) {
    $countries = array( 
        'AC' => '247', 
        'AD' => '376', 
        'AE' => '971', 
        'AF' => '93', 
        'AG' => '1268', 
        'AI' => '1264', 
        'AL' => '355', 
        'AM' => '374', 
        'AO' => '244', 
        'AQ' => '672', 
        'AR' => '54', 
        'AS' => '1684', 
        'AT' => '43', 
        'AU' => '61', 
        'AW' => '297', 
        'AX' => '358', 
        'AZ' => '994', 
        'BA' => '387', 
        'BB' => '1246', 
        'BD' => '880', 
        'BE' => '32', 
        'BF' => '226', 
        'BG' => '359', 
        'BH' => '973', 
        'BI' => '257', 
        'BJ' => '229', 
        'BL' => '590', 
        'BM' => '1441', 
        'BN' => '673', 
        'BO' => '591', 
        'BQ' => '599', 
        'BR' => '55', 
        'BS' => '1242', 
        'BT' => '975', 
        'BW' => '267', 
        'BY' => '375', 
        'BZ' => '501', 
        'CA' => '1', 
        'CC' => '61', 
        'CD' => '243', 
        'CF' => '236', 
        'CG' => '242', 
        'CH' => '41', 
        'CI' => '225', 
        'CK' => '682', 
        'CL' => '56', 
        'CM' => '237', 
        'CN' => '86', 
        'CO' => '57', 
        'CR' => '506', 
        'CU' => '53', 
        'CV' => '238', 
        'CW' => '599', 
        'CX' => '61', 
        'CY' => '357', 
        'CZ' => '420', 
        'DE' => '49', 
        'DJ' => '253', 
        'DK' => '45', 
        'DM' => '1767', 
        'DO' => '1809', 
        'DO' => '1829', 
        'DO' => '1849', 
        'DZ' => '213', 
        'EC' => '593', 
        'EE' => '372', 
        'EG' => '20', 
        'EH' => '212', 
        'ER' => '291', 
        'ES' => '34', 
        'ET' => '251', 
        'EU' => '388', 
        'FI' => '358', 
        'FJ' => '679', 
        'FK' => '500', 
        'FM' => '691', 
        'FO' => '298', 
        'FR' => '33', 
        'GA' => '241', 
        'GB' => '44', 
        'GD' => '1473', 
        'GE' => '995', 
        'GF' => '594', 
        'GG' => '44', 
        'GH' => '233', 
        'GI' => '350', 
        'GL' => '299', 
        'GM' => '220', 
        'GN' => '224', 
        'GP' => '590', 
        'GQ' => '240', 
        'GR' => '30', 
        'GT' => '502', 
        'GU' => '1671', 
        'GW' => '245', 
        'GY' => '592', 
        'HK' => '852', 
        'HN' => '504', 
        'HR' => '385', 
        'HT' => '509', 
        'HU' => '36', 
        'ID' => '62', 
        'IE' => '353', 
        'IL' => '972', 
        'IM' => '44', 
        'IN' => '91', 
        'IO' => '246', 
        'IQ' => '964', 
        'IR' => '98', 
        'IS' => '354', 
        'IT' => '39', 
        'JE' => '44', 
        'JM' => '1876', 
        'JO' => '962', 
        'JP' => '81', 
        'KE' => '254', 
        'KG' => '996', 
        'KH' => '855', 
        'KI' => '686', 
        'KM' => '269', 
        'KN' => '1869', 
        'KP' => '850', 
        'KR' => '82', 
        'KW' => '965', 
        'KY' => '1345', 
        'KZ' => '7', 
        'LA' => '856', 
        'LB' => '961', 
        'LC' => '1758', 
        'LI' => '423', 
        'LK' => '94', 
        'LR' => '231', 
        'LS' => '266', 
        'LT' => '370', 
        'LU' => '352', 
        'LV' => '371', 
        'LY' => '218', 
        'MA' => '212', 
        'MC' => '377', 
        'MD' => '373', 
        'ME' => '382', 
        'MF' => '590', 
        'MG' => '261', 
        'MH' => '692', 
        'MK' => '389', 
        'ML' => '223', 
        'MM' => '95', 
        'MN' => '976', 
        'MO' => '853', 
        'MP' => '1670', 
        'MQ' => '596', 
        'MR' => '222', 
        'MS' => '1664', 
        'MT' => '356', 
        'MU' => '230', 
        'MV' => '960', 
        'MW' => '265', 
        'MX' => '52', 
        'MY' => '60', 
        'MZ' => '258', 
        'NA' => '264', 
        'NC' => '687', 
        'NE' => '227', 
        'NF' => '672', 
        'NG' => '234', 
        'NI' => '505', 
        'NL' => '31', 
        'NO' => '47', 
        'NP' => '977', 
        'NR' => '674', 
        'NU' => '683', 
        'NZ' => '64', 
        'OM' => '968', 
        'PA' => '507', 
        'PE' => '51', 
        'PF' => '689', 
        'PG' => '675', 
        'PH' => '63', 
        'PK' => '92', 
        'PL' => '48', 
        'PM' => '508', 
        'PR' => '1787', 
        'PR' => '1939', 
        'PS' => '970', 
        'PT' => '351', 
        'PW' => '680', 
        'PY' => '595', 
        'QA' => '974', 
        'QN' => '374', 
        'QS' => '252', 
        'QY' => '90', 
        'RE' => '262', 
        'RO' => '40', 
        'RS' => '381', 
        'RU' => '7', 
        'RW' => '250', 
        'SA' => '966', 
        'SB' => '677', 
        'SC' => '248', 
        'SD' => '249', 
        'SE' => '46', 
        'SG' => '65', 
        'SH' => '290', 
        'SI' => '386', 
        'SJ' => '47', 
        'SK' => '421', 
        'SL' => '232', 
        'SM' => '378', 
        'SN' => '221', 
        'SO' => '252', 
        'SR' => '597', 
        'SS' => '211', 
        'ST' => '239', 
        'SV' => '503', 
        'SX' => '1721', 
        'SY' => '963', 
        'SZ' => '268', 
        'TA' => '290', 
        'TC' => '1649', 
        'TD' => '235', 
        'TG' => '228', 
        'TH' => '66', 
        'TJ' => '992', 
        'TK' => '690', 
        'TL' => '670', 
        'TM' => '993', 
        'TN' => '216', 
        'TO' => '676', 
        'TR' => '90', 
        'TT' => '1868', 
        'TV' => '688', 
        'TW' => '886', 
        'TZ' => '255', 
        'UA' => '380', 
        'UG' => '256', 
        'UK' => '44', 
        'US' => '1', 
        'UY' => '598', 
        'UZ' => '998', 
        'VA' => '379', 
        'VA' => '39', 
        'VC' => '1784', 
        'VE' => '58', 
        'VG' => '1284', 
        'VI' => '1340', 
        'VN' => '84', 
        'VU' => '678', 
        'WF' => '681', 
        'WS' => '685', 
        'XC' => '991', 
        'XD' => '888', 
        'XG' => '881', 
        'XL' => '883', 
        'XN' => '857', 
        'XN' => '858', 
        'XN' => '870', 
        'XP' => '878', 
        'XR' => '979', 
        'XS' => '808', 
        'XT' => '800', 
        'XV' => '882', 
        'YE' => '967', 
        'YT' => '262', 
        'ZA' => '27', 
        'ZM' => '260', 
        'ZW' => '263' 
    );

    return ( $country == '' ) ? $countries : ( isset( $countries[$country] ) ? $countries[$country] : '' );
}

