<?php
if (!defined('ABSPATH')) {
    exit;
}

function myownsms_plg_update() {
    add_submenu_page(
        'myownsms_menu', __('Update', 'wpmyownsms'), __('Update', 'wpmyownsms'), 'administrator', 'myownsms_plg_update', create_function(null, 'myownsms_plg( "update" );')
    );
}
add_action('admin_menu', 'myownsms_plg_update');

function myownsms_update_render() {
    $total_errors = array();
    $upload = trim(myown_getQueryValue('submit'));
    if ($upload && !empty($upload) && $upload == 'Update') {
        if (check_admin_referer('update_upload')) {
            $movefile = zip_upload("WPMYOWNSMS_UPDATE");
            if (!$movefile || isset($movefile['error'])) {
                $total_errors[] = strip_tags(stripslashes($movefile['error']));
            } else {
                $zip = new ZipArchive;
                if ($zip->open($movefile['file']) === TRUE) {
                    //file_exists
                    if ( $zip->extractTo(WP_MYOWNSMS_UPDATE, array('wpmyownsms/wpmyownsms.php')) == true){
                    $local_version = get_option('myownsms_db_version');
                        $meta_dati = get_plugin_data(WP_MYOWNSMS_UPDATE.'/wpmyownsms/wpmyownsms.php');
                        if ( version_compare( $meta_dati['Version'] , $local_version, '>') ){
                            $return = deactivate_plugins('wpmyownsms/wpmyownsms.php');
                        if( is_wp_error( $return ) ) {
                            $total_errors[] = 'deactive '.$return->get_error_message();
                        } else {
                            $total_errors[] = 'deactive ok';
                        }
                        $zip->extractTo(WP_MYOWNSMS_ROOT_PLUGIN);
                            myown_deleteDir(WP_MYOWNSMS_UPDATE.'/wpmyownsms');
                        $zip->close();
                        unlink($movefile['file']);
                        wp_redirect( self_admin_url( "plugins.php?plugin_status=all" ) );
                    } else {
                        $total_errors[] = __('The installed plugin is more recent than the submissive one');
                    }
                        myown_deleteDir(WP_MYOWNSMS_UPDATE.'/wpmyownsms');
                    } else {
                        $total_errors[] = __('Invalid plugin submitted'); 
                    }
                    $zip->close();
                    unlink($movefile['file']);
                } else {
                    unlink($movefile['file']);
                    $total_errors[] = __('Error to extract file.');
                }
            }
            if (count($total_errors)) {
                foreach ($total_errors as $err) {
                    add_settings_error(
                        'requireZipFile', 'number', $err, 'error'
                    );
                }
            } else {
                add_settings_error(
                    'requireZipFile', 'number', __("Plugins updated!.\n", 'wpmyownsms'), 'updated'
                );
            }
        }
    }
    include_once WP_MYOWNSMS_TEMPLATE . "update/update_upload.php";
}
add_action('update_render', 'myownsms_update_render');

function zip_upload($file_id) {
    if (!function_exists('wp_handle_upload')) {
        require_once( ABSPATH . 'wp-admin/includes/file.php' );
    }
    $uploadedfile = $_FILES[$file_id];

    function wpse_183245_upload_dir($dirs)
    {
        $dirs['subdir'] = '/import';
        $dirs['path'] = WP_MYOWNSMS_UPDATE;
        $dirs['url'] = WP_MYOWNSMS_ASSETS_UPDATE;
        return $dirs;
    }
    add_filter('upload_dir', 'wpse_183245_upload_dir');

    function so_3261107_hash_filename($filename)
    {
        $ext = pathinfo($filename, PATHINFO_EXTENSION);
        $name = basename($filename, $ext);
        return $name . $ext;
    }
    add_filter('sanitize_file_name', 'so_3261107_hash_filename', 10);

    $movefile = wp_handle_upload(
        $uploadedfile, array('test_form' => false, 'mimes' => 
            array(
                'zip'		=> 'application/x-zip-compressed',
                'zip'		=> 'application/zip',
            )
    ));

    remove_filter('sanitize_file_name', 'so_3261107_hash_filename', 10);
    remove_filter('upload_dir', 'wpse_183245_upload_dir');
    return $movefile;
}
