<?php
/*
Plugin Name: MyOwnSms
Plugin URI: https://www.myownsms.com/
Description: Send SMS through your smartphone and phone plan. SMS Marketing and bulk message. With patent filed.
Version: 1.3.3
Author: M&M Solutions Srls
Author URI: https://www.myownsms.com/
Text Domain: MyOwnSMS

WC requires at least: 4.x.x
WC tested up to: 4.9.x
*/

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if( ! is_ssl() ) {
    exit;
}

require_once dirname( __FILE__ ) . '/config/config.inc.php';

define( 'WP_MYOWNSMS_ADMIN_URL', get_admin_url() );
define( 'WP_MYOWNSMS_ASSETS', plugin_dir_url( __FILE__ ) . 'assets/');
define( 'WP_MYOWNSMS_ASSETS_IMPORT', plugin_dir_url( __FILE__ ) . 'import');
define( 'WP_MYOWNSMS_ASSETS_UPDATE', plugin_dir_url( __FILE__ ) . 'update');

function wpmyown_install() {
    if ( !is_plugin_active('woocommerce/woocommerce.php')) {
        deactivate_plugins(__FILE__);
        // Throw an error in the wordpress admin console
        $error_message = __('This plugin requires <a href="http://wordpress.org/extend/plugins/woocommerce/">WooCommerce</a> to be active!', 'woocommerce');
        die($error_message);
    }
    
    if ( is_plugin_active('wpmyownsmsmarketing/wpmyownsmsmarketing.php')) {
        deactivate_plugins(__FILE__);
        $error_message = __('This plugin <a href="https://www.myownsms.com/">WPMyOwnSmsMarketing</a> is active!', 'wpmyownsms');
        die($error_message);
    }
    
    if ( is_plugin_active('wpmyownsmsnotifications/wpmyownsmsnotifications.php')) {
        deactivate_plugins(__FILE__);
        $error_message = __('This plugin <a href="https://www.myownsms.com/">WPMyOwnSmsNotifications</a> is active!', 'wpmyownsms');
        die($error_message);
    }

    include_once dirname( __FILE__ ) . '/install.php';
    require_once( ABSPATH . 'wp-admin/includes/upgrade.php' );
    dbDelta( $create_myownsms_devices );
    dbDelta( $create_myownsms_polling );
    dbDelta( $create_myownsms_subscriber );
    dbDelta( $create_myownsms_woo_customers );
    dbDelta( $create_myownsms_import_customers );
    update_option( 'myownsms_db_version', WP_MYOWNSMS_VERSION );
    
}
register_activation_hook( __FILE__, 'wpmyown_install' );

function wpmyown_uninstall() {
    global $wpdb, $table_prefix;    
    $drop_table = "DROP TABLE IF EXISTS {$table_prefix}myownsms_devices; ";
    $wpdb->query($drop_table);
    $drop_table = "DROP TABLE IF EXISTS {$table_prefix}myownsms_polling; ";
    $wpdb->query($drop_table);
    $drop_table = "DROP TABLE IF EXISTS {$table_prefix}myownsms_subscriber; ";
    $wpdb->query($drop_table);
    $drop_table = "DROP TABLE IF EXISTS {$table_prefix}myownsms_woo_customers; ";
    $wpdb->query($drop_table);
    $drop_table = "DROP TABLE IF EXISTS {$table_prefix}myownsms_import_customers; ";
    $wpdb->query($drop_table);
    delete_option( 'myownsms_db_version' );
    delete_option( 'myownsms_plg_registration' );
    delete_option( 'myownsms_plg_fileimport' );
    delete_option( 'myownsms_plg_notifications' );
}

function add_action_links( $links ) {
    $_links = array_merge( $links, array(
        '<a href="' . admin_url( 'admin.php?page=myownsms_menu' ) . '">Configuration</a>',
        '<a href="' . admin_url( 'admin.php?page=myownsms_menu&tab=update' ) . '">Update</a>',
    ) );
    return $_links;
}
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'add_action_links' );

function load_myownsms() {
    load_plugin_textdomain( 'wpmyownsms', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
}
add_action( 'init', 'load_myownsms' );

function myownsms_plg_menu() {	
	$hook = add_menu_page(
		'MyOwnSMS',
		'MyOwnSMS',
		'administrator',
		'myownsms_menu',
		'myownsms_plg'
	);
    add_action( "load-$hook", 'add_options' );
}
add_action( 'admin_menu', 'myownsms_plg_menu' );

function add_options() {
  $option = 'per_page';
  $args = array(
         'label' => __('Customers', 'wpmyownsms'),
         'default' => 10,
         'option' => 'customers_per_page'
         );
  add_screen_option( $option, $args );
}

function pagination_set_option($status, $option, $value) {
    if ( 'customers_per_page' == $option ) return $value;
    return $status;
}
add_filter('set-screen-option', 'pagination_set_option', 10, 3);

function myownsms_plg( $active_tab = '' ) {
?>
	<div class="wrap">
        <link rel="stylesheet" id="wpsms-admin-css-css" href="<?php echo WP_MYOWNSMS_ASSETS; ?>css/myownsmsadmin.css" type="text/css" media="all">
		<link rel="stylesheet" id="wpsms-kv_js_time_style" href="<?php echo WP_MYOWNSMS_ASSETS; ?>css/jquery-ui-timepicker-addon.css" type="text/css" media="all">		
		<link rel="stylesheet" id="wpsms-jquery-style" href="https://ajax.googleapis.com/ajax/libs/jqueryui/1.10.4/themes/smoothness/jquery-ui.css" type="text/css" media="all">
		<script>
            var smartDonationsOldJQuery=jQuery;
            var smartDonationsOldCashSign=$;
        </script>
        <script language="javascript" type="text/javascript" src="https://code.jquery.com/jquery-1.9.1.js"></script>
        <script language="javascript" type="text/javascript" src="https://code.jquery.com/ui/1.10.4/jquery-ui.js"></script>
        <script>
            MyOwnjQuery = jQuery.noConflict(true);
            window.jQuery = smartDonationsOldJQuery;
            window.$ = smartDonationsOldCashSign;
        </script>
		<script src="<?php echo WP_MYOWNSMS_ASSETS; ?>js/jquery-ui-timepicker-addon.js"></script>
        <div id="icon-themes" class="icon32"></div>
		<img class="logo" src="<?php echo WP_MYOWNSMS_ASSETS; ?>images/logo-3d.png">
		<div class="intro">MyOwnSMS is the first plugin without use of external gateway, that allow to send SMS by own smartphone using own telephone plan...</div>
		<div class="intro">With patent filed... Imagine the future!</div>
		<div class="intro">Use "MyOwnSMS APP" on your Android device</div>
		<?php settings_errors(); ?>
		
		<?php if( isset( $_GET[ 'tab' ] ) ) {
			$active_tab = $_GET[ 'tab' ];
		} else if( $active_tab == 'notifications' ) {
			$active_tab = 'notifications';
        } else if( $active_tab == 'campaign' ) {
			$active_tab = 'campaign';
        } else if( $active_tab == 'import' ) {
			$active_tab = 'import';
        } else if( $active_tab == 'history' ){
            $active_tab = 'history';
		} else if( $active_tab == 'update' ){
            $active_tab = 'update';
		} else {
			$active_tab = 'configuration';
		}  ?>
		
		<h2 class="nav-tab-wrapper">
			<a href="?page=myownsms_menu&tab=configuration" class="nav-tab <?php echo $active_tab == 'configuration' ? 'nav-tab-active' : ''; ?>"><?php _e( 'Configuration', 'wpmyownsms' ); ?></a>
			<a href="?page=myownsms_menu&tab=notifications" class="nav-tab <?php echo $active_tab == 'notifications' ? 'nav-tab-active' : ''; ?>"><?php _e( 'Notifications', 'wpmyownsms' ); ?></a>
            <a href="?page=myownsms_menu&tab=campaign" class="nav-tab <?php echo $active_tab == 'campaign' ? 'nav-tab-active' : ''; ?>"><?php _e( 'Store Campaign', 'wpmyownsms' ); ?></a>
			<a href="?page=myownsms_menu&tab=import" class="nav-tab <?php echo $active_tab == 'import' ? 'nav-tab-active' : ''; ?>"><?php _e( 'CSV Campaign', 'wpmyownsms' ); ?></a>
            <a href="?page=myownsms_menu&tab=history" class="nav-tab <?php echo $active_tab == 'history' ? 'nav-tab-active' : ''; ?>"><?php _e( 'History', 'wpmyownsms' ); ?></a>
            <a href="?page=myownsms_menu&tab=update" class="nav-tab <?php echo $active_tab == 'update' ? 'nav-tab-active' : ''; ?>"><?php _e( 'Update', 'wpmyownsms' ); ?></a>
		</h2>
			<?php
				if( $active_tab == 'configuration' ) {
                    do_action( 'configuration_render');
				} elseif( $active_tab == 'notifications' ) {
                    do_action('notifications_render');
				} elseif( $active_tab == 'campaign' ) {
                    do_action('campaign_render');
				} elseif( $active_tab == 'import' ) {
                    do_action('import_render');
				} elseif ( $active_tab == 'history' ){
                    do_action('history_render');
                } elseif ( $active_tab == 'update' ){
                    do_action('update_render');
                } else {
                    do_action( 'configuration_render');
                }
			?>
        </div>
<?php
}

include WP_MYOWNSMS_CONTROLLER.'configurations/MyOwnConfiguration.php';
include WP_MYOWNSMS_CONTROLLER.'notifications/MyOwnNotifications.php';
include WP_MYOWNSMS_CONTROLLER.'campaign/MyOwnCampaign.php';
include WP_MYOWNSMS_CONTROLLER.'import/MyOwnImport.php';
include WP_MYOWNSMS_CONTROLLER.'history/MyOwnHistory.php';
include WP_MYOWNSMS_CONTROLLER.'update/MyOwnUpdate.php';
?>
